"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.useFileSystem = void 0;
var react_1 = require("react");
var react_native_fs_1 = __importDefault(require("react-native-fs"));
function useFileSystem() {
    var _this = this;
    var _a = (0, react_1.useState)(null), file = _a[0], setFile = _a[1];
    var _b = (0, react_1.useState)(0), progress = _b[0], setProgress = _b[1];
    var _c = (0, react_1.useState)(false), downloading = _c[0], setDownloading = _c[1];
    var _d = (0, react_1.useState)(0), size = _d[0], setSize = _d[1];
    var _e = (0, react_1.useState)(null), error = _e[0], setError = _e[1];
    var _f = (0, react_1.useState)(false), success = _f[0], setSuccess = _f[1];
    var downloadFile = (0, react_1.useCallback)(function (fromUrl, toFile) {
        var toFilePath = "".concat(react_native_fs_1.default.CachesDirectoryPath, "/").concat(toFile);
        return react_native_fs_1.default.downloadFile({
            fromUrl: fromUrl,
            toFile: toFilePath,
            begin: function (_a) {
                var contentLength = _a.contentLength;
                setDownloading(true);
                setSize(contentLength);
            },
            progress: function (_a) {
                var bytesWritten = _a.bytesWritten, contentLength = _a.contentLength;
                setProgress(Math.round((bytesWritten / contentLength) * 100));
            },
        })
            .promise.then(function (_a) { return __awaiter(_this, [_a], void 0, function (_b) {
            var _c, filePath, fileSize;
            var statusCode = _b.statusCode;
            return __generator(this, function (_d) {
                switch (_d.label) {
                    case 0:
                        if (!(statusCode === 200)) return [3 /*break*/, 2];
                        return [4 /*yield*/, react_native_fs_1.default.stat(toFilePath)];
                    case 1:
                        _c = _d.sent(), filePath = _c.path, fileSize = _c.size;
                        setFile(filePath);
                        setSize(fileSize);
                        setSuccess(true);
                        setError(null);
                        return [2 /*return*/, { uri: filePath, mimeType: null }];
                    case 2:
                        setFile(null);
                        setSize(0);
                        setSuccess(false);
                        setError("Unknown error ".concat(statusCode));
                        return [2 /*return*/, { uri: null, mimeType: null }];
                }
            });
        }); })
            .catch(function (err) {
            if (err instanceof Error) {
                setError(err.message);
            }
            else
                setError("Unknown Error");
            setFile(null);
            setSize(0);
            setSuccess(false);
            console.log(err);
            return { uri: null, mimeType: null };
        })
            .finally(function () { return setDownloading(false); });
    }, []);
    var getFileInfo = (0, react_1.useCallback)(function (fileUri) { return __awaiter(_this, void 0, void 0, function () {
        var exists, _a, uri, isDirectoryFn, fileSize, isDirectory;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0: return [4 /*yield*/, react_native_fs_1.default.exists(fileUri)];
                case 1:
                    exists = _b.sent();
                    return [4 /*yield*/, react_native_fs_1.default.stat(fileUri)];
                case 2:
                    _a = _b.sent(), uri = _a.path, isDirectoryFn = _a.isDirectory, fileSize = _a.size;
                    isDirectory = isDirectoryFn();
                    return [2 /*return*/, {
                            uri: uri,
                            exists: exists,
                            isDirectory: isDirectory,
                            size: fileSize,
                        }];
            }
        });
    }); }, []);
    return {
        file: file,
        progress: progress,
        downloading: downloading,
        size: size,
        error: error,
        success: success,
        documentDirectory: react_native_fs_1.default.DocumentDirectoryPath,
        bundleDirectory: react_native_fs_1.default.MainBundlePath,
        cacheDirectory: react_native_fs_1.default.CachesDirectoryPath,
        readAsStringAsync: function (fileUri, options) {
            return react_native_fs_1.default.readFile(fileUri, options === null || options === void 0 ? void 0 : options.encoding);
        },
        writeAsStringAsync: function (fileUri, contents, options) {
            return react_native_fs_1.default.writeFile(fileUri, contents, options === null || options === void 0 ? void 0 : options.encoding);
        },
        deleteAsync: function (fileUri) { return react_native_fs_1.default.unlink(fileUri); },
        downloadFile: downloadFile,
        getFileInfo: getFileInfo,
    };
}
exports.useFileSystem = useFileSystem;
